# Natural Language Toolkit: upper_limit

 def upper_limit(sents):
     cfdist = nltk.ConditionalFreqDist()
     for sent in sents:
         p = [(None, None)] # empty token/tag pair
         trigrams = zip(p+p+sent, p+sent+p, sent+p+p)
         for (pair1,pair2,pair3) in trigrams:
             context = (pair1[1], pair2[1], pair3[0]) # last 2 tags, this word
             cfdist[context].inc(pair3[1])            # current tag
     total = ambiguous = 0
     for cond in cfdist.conditions():
         if cfdist[cond].B() > 1:
             ambiguous += cfdist[cond].N()
         total += cfdist[cond].N()
     return float(ambiguous) / total

